// company.service.ts
import { Injectable } from '@angular/core';
import { Company } from '../models/company.model';

@Injectable({
  providedIn: 'root'
})
export class CompanyService {
  private company: Company = {
    name: '未来科技股份有限公司',
    address: '北京市海淀区中关村软件园二期8号楼',
    industry: '人工智能与大数据',
    description: '未来科技是一家专注于人工智能和大数据技术研发的高科技企业，致力于为企业提供智能化解决方案。我们拥有一支由博士和硕士组成的高素质研发团队，在自然语言处理、计算机视觉和机器学习领域具有深厚的技术积累。',
    jobOpenings: [
      {
        title: '高级前端工程师',
        description: '负责公司核心产品的前端开发工作，参与技术方案设计和架构优化。',
        requirements: '3年以上前端开发经验，精通Angular/React/Vue等框架'
      },
      {
        title: 'Java后端开发',
        description: '参与公司后端服务开发，负责高并发、分布式系统的设计与实现。',
        requirements: '5年以上Java开发经验，熟悉Spring Cloud微服务架构'
      },
      {
        title: 'AI算法工程师',
        description: '负责机器学习算法的研发和优化，参与产品智能化功能的实现。',
        requirements: '硕士及以上学历，熟悉TensorFlow/PyTorch等框架'
      }
    ]
  };

  getCompany(): Company {
    return {...this.company};
  }

  updateCompany(updatedCompany: Company): void {
    this.company = {...updatedCompany};
  }
}